image:
  name: "hashicorp/terraform"
  entrypoint:
  - '/usr/bin/env'
  - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'

stages:
- validate
- plan
- deploy

cache:
  paths:
    - .terraform

before_script:
  - terraform --version
  - terraform init

validate:
  stage: validate
  script:
    - terraform validate

plan:
  stage: plan
  artifacts:
    paths:
      - prod.tfplan
    expire_in: 1 week
  script:
    - terraform workspace select production
    - terraform plan -input=false -out=prod.tfplan
  dependencies:
    - validate

apply:
  stage: deploy
  when: manual
  script:
    - terraform workspace select production
    - terraform apply -auto-approve -input=false prod.tfplan
  dependencies:
    - plan